#pragma once

#include <systypes/base.h>

#include "page_mapper.h"
#include "resource.h"



/* A pager exposing a dataspace. */

class Pager : public Resource
{
protected:
    offset_t _start, _size;
    PageMapper *_mapper;

public:
    explicit Pager(PageMapper *mapper);

    virtual void close();

    /* Paging methods. */

    virtual long map(unsigned long offset, l4_addr_t hot_spot, unsigned long flags, l4_snd_fpage_t *region);

    /* Limit methods. */

    offset_t get_data_size();

    /* Mapped file methods. */

    virtual long mmap(offset_t position, offset_t length, offset_t *start_pos, offset_t *end_pos, offset_t *data_end);
};

// vim: tabstop=4 expandtab shiftwidth=4
